
#define adress 1

//Each row is three bytes(R,G,B)
//                   R        B        G
byte data[12] = {0b01000001,0b01000001,0b01000001,   // Column 1 
                 0b01000001,0b01000001,0b01000001,   // Column 2
                 0b01000001,0b01000001,0b01000001,   // Column 3 
                 0b00111110,0b00111110,0b00111110};  // Column 4
int counter = 0;
int bitCounter = 1;

boolean recordIoData = false;
int ioCounter = 0;



void setup()
{
  Serial.begin(9600);
  for(int i = 2; i < 14; i++)
  {
     pinMode(i, OUTPUT); 
  }
  pinMode(A0, OUTPUT);
  pinMode(A1, OUTPUT);
  pinMode(A2, OUTPUT);
}

byte getCurrent(byte b, byte counter)
{
  return(b & counter);
}

void drawPanel()
{
  byte a0 = counter & 1;
 byte a1 = counter & 2;
 byte a2 = counter & 4;
 
 //  Set to 8th row in order to switch off the rwo drivers before changin the row content
 digitalWrite(A0, 1);
 digitalWrite(A1, 1);
 digitalWrite(A2, 1);
 
 // Setting the row content 
 for(int i = 0; i < 12; i ++)
 {
   digitalWrite(i + 2, getCurrent(data[i], bitCounter));
 }

 // Activating the current row again
 digitalWrite(A0, a0);
 digitalWrite(A1, a1);
 digitalWrite(A2, a2);
 
 counter ++;
 bitCounter *= 2;
 
 if(counter >= 7) counter = 0;
 if(bitCounter >= 128) bitCounter = 1;
}

void processByte(byte b)
{
  if((b & 128) != 0) 
  {
    if((b & 127) == adress) recordIoData = true;
  }
  else
  {
    if(recordIoData)
    {
      data[ioCounter] = b;
      ioCounter ++;
      if(ioCounter >= 13) 
      {
        recordIoData = false;
        ioCounter = 0;
      }
    }
  }
  
  
  
}

void checkIo()
{
  while (Serial.available() > 0) 
  {
   processByte(Serial.read()); 
  }
}

void loop()
{
 drawPanel();
 checkIo();
 delay(2);
}
